{ GIF loader test & example. }
{ by Charlie/iNQ 2002.11.20  }

{$MODE FPC}
{$ASMMODE INTEL}
Program GIFTest;

Uses CRT,GIFLoad;

Var  MyGIF     : PGIFDecoder;
     MyGIFFile : File;

     MyGIFData     : Pointer;
     MyGIFDataSize : DWord;

     Counter : DWord;

     { Temporary variable for PutGIFData. }
     TmpAddr : Pointer;

{ Some easy VGA Stuff }
Procedure InitVGA; Assembler;
Asm
 MOV AX,13h
 INT 10h
End;

Procedure SetRGBPalette(Color : Byte; R,G,B : Byte); Assembler;
Asm
 MOV DX,$03C8; MOV AL,Color; OUT DX,AL; INC DX
 MOV AL,R; OUT DX,AL
 MOV AL,G; OUT DX,AL
 MOV AL,B; OUT DX,AL
End;

Procedure CopyVGA; Assembler;
Asm
 MOV ECX,16000
 MOV ESI,MyGIFData
 MOV EDI,$A0000
 @LoopHead:
  MOV EAX,[ESI]
  MOV GS:[EDI],EAX
  ADD ESI,4
  ADD EDI,4
  DEC ECX
 JNZ @LoopHead
End ['EAX','ESI','EDI','ECX'];


{ !!! CUSTOM I/O ROUTINES !!! }

Procedure GetGIFData(Var LoadBuffer; SizeToLoad : Word; Var LoadedSize : Word);
Begin
 BlockRead(MyGIFFile,LoadBuffer,SizeToLoad,LoadedSize);
End;

Procedure PutGIFData(DecodedValue : Integer);
Begin
 Byte(TmpAddr^):=Byte(DecodedValue);
 Inc(DWord(TmpAddr),1);
End;

{ !!! CUSTOM I/O ROUTINES !!! }


Begin
 { Open the GIF file. Since we're using external I/O routines }
 { we have to do it ourself. }
 Assign(MyGIFFile,'example.gif');
 Reset(MyGIFFile,1);
 If IOResult<>0 Then Begin
   WriteLn('Cannot open file!'); Halt;
 End;

 { Init our decoder object. Easy. }
 MyGIF:=New(PGIFDecoder, Init);
 If MyGIF=Nil Then Begin
   Writeln('Cannot initialize decoder!'); Halt;
 End;

 { Assign our I/O routines. These allows easy integration of }
 { the decoder into various environments. }
 MyGIF^.GetData:=@GetGiFData;
 MyGIF^.PutData:=@PutGiFData;

 { Now read GIF header data, and initialize some structures }
 MyGIF^.InitHeader;
 If MyGIF^.ErrorCode>0 Then Begin
   Writeln('GIF header problem!'); Halt;
 End;

 { Allocate some memory for GIF bitmap data, according to }
 { header values. }
 MyGIFDataSize:=MyGIF^.ScreenDesc.Width*MyGIF^.ScreenDesc.Height;
 GetMem(MyGIFData,MyGIFDataSize);
 { Remember to clear TmpAddr before every new decode! }
 TmpAddr:=MyGIFData;

 { Okay, now really decode the stuff into memory! }
 MyGIF^.Decode;

 { Display our picture, and wait for a keypress. }
 InitVGA;
 For Counter:=0 To 255 Do Begin
   With MyGIF^.Palette[Counter] Do Begin
     { Setting VGA palette. }
     SetRGBPalette(Counter,Red>>2,Green>>2,Blue>>2);
   End;
 End;

 { Now display the picture }
 CopyVGA;

 Repeat Until Keypressed;

 { Usual cleanup stuff. }
 TextMode(CO80);
 FreeMem(MyGIFData,MyGIFDataSize);
 Dispose(MyGIF, Done);
 Close(MyGIFFile);
End.

